//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Aqua
#property indicator_color2  Yellow

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern double          StochPeriod     = 9;
extern ENUM_MA_METHOD  StochMaMethod   = MODE_EMA;
extern ENUM_STO_PRICE  StochPrice      = PRICE_CLOSE;
extern double          stoch_max       = 53;
extern double          stoch_min       = 47;
extern double          atr_period      = 7;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = true;
extern bool            alertsEmail     = false;
extern bool            alertsNotify    = false;

extern double          DotsUpperGap    = 0.5;
extern double          DotsLowerGap    = 0.5;
extern int             DotWidth        = 2;
extern bool            DotsOnFirstBar  = false;

//
//
//
//
//

double arrUp[];
double arrDn[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,arrUp);  SetIndexStyle(0,DRAW_ARROW,0,DotWidth); SetIndexArrow(0,108);
      SetIndexBuffer(1,arrDn);  SetIndexStyle(1,DRAW_ARROW,0,DotWidth); SetIndexArrow(1,108);
      SetIndexBuffer(2,trend); 
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == -99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" BrainTrend Signal");   
return(0);
}  
int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { arrUp[0] = limit+1; return(0); }
           
            if (TimeFrame!=Period())
            {
               int shift = -1; if (DotsOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,TimeFrame,Time[i]);   
                   int x = iBarShift(NULL,TimeFrame,Time[i+shift]);            
                   
               if (x!=y)
               {
                   arrUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StochPeriod,StochMaMethod,StochPrice,stoch_max,stoch_min,atr_period,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,y);
                   arrDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StochPeriod,StochMaMethod,StochPrice,stoch_max,stoch_min,atr_period,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,1,y);    
               }
               else
               {
                   arrUp[i] = EMPTY_VALUE;
                   arrDn[i] = EMPTY_VALUE; 
               }      
            }
     return(0);
     }
     
     //
     //
     //
     //
     //

     for(i=limit; i>=0; i--)
     {
        double atr    = iATR(NULL,0,atr_period,i)/2.3;
        double stoch  = iStochastic(NULL,0,StochPeriod,StochPeriod,1,StochMaMethod,StochPrice,1,i);
        double cldiff =  MathAbs(Close[i] - Close[i+2]);
        double gap    = iATR(NULL,0,20,i); 
        
           trend[i] = trend[i+1];
           if (cldiff > atr && stoch < stoch_min) trend[i] =-1;
           if (cldiff > atr && stoch > stoch_max) trend[i] = 1;
        
           //
           //
           //
           //
           //
    
           arrUp[i] = EMPTY_VALUE;
           arrDn[i] = EMPTY_VALUE;
           if (trend[i]!= trend[i+1])
           if (trend[i] == 1)
                 arrUp[i] = Low[i]  - DotsLowerGap * gap;
           else  arrDn[i] = High[i] + DotsUpperGap * gap;
     }      
     
   //
   //
   //
   //
   //
         
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }
return(0);
}
      
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Brain Trend Signal ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Brain Trend Signal "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


